// Inogeni-OpenCV-Demo.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <iostream>

using namespace cv;
using namespace std;

#define SMALL_IMAGE_WIDTH 548
#define SMALL_IMAGE_HEIGHT 308

void cameraTrd();

void cameraTrd()
{
	//g_Logger.Log(LL_INFO,"%s Streaming Thread Start",m_Name.c_str());
	bool bSuccess = false;
	bool retval = false;
	int nImageCounter = 0;
	char sImageCounter[32] = {}; 
	std::string s = "";
	Mat frame;
	Mat frameSmall;
	int key = 0;

	VideoCapture * pVCap = new VideoCapture(0); 

    if (pVCap) 
    {

		if( pVCap->isOpened() )
		{	

			//Reading some parameters to understand the 4K issue;
			//double temp = pVCap->get(CV_CAP_PROP_XI_DATA_FORMAT);
			//temp = pVCap->get(CV_CAP_PROP_POS_MSEC);// Current position of the video file in milliseconds.
			//temp = pVCap->get(CV_CAP_PROP_POS_FRAMES);// 0-based index of the frame to be decoded/captured next.
			//temp = pVCap->get(CV_CAP_PROP_POS_AVI_RATIO);// Relative position of the video file: 0 - start of the film, 1 - end of the film.
			//temp = pVCap->get(CV_CAP_PROP_FRAME_WIDTH);// Width of the frames in the video stream.
			//temp = pVCap->get(CV_CAP_PROP_FRAME_HEIGHT);// Height of the frames in the video stream.
			//temp = pVCap->get(CV_CAP_PROP_FPS);// Frame rate.
			//temp = pVCap->get(CV_CAP_PROP_FOURCC);// 4-character code of codec.
			//temp = pVCap->get(CV_CAP_PROP_FRAME_COUNT);// Number of frames in the video file.
			//temp = pVCap->get(CV_CAP_PROP_FORMAT);// Format of the Mat objects returned by retrieve() .
			//temp = pVCap->get(CV_CAP_PROP_MODE);// Backend-specific value indicating the current capture mode.
			//temp = pVCap->get(CV_CAP_PROP_BRIGHTNESS);// Brightness of the image (only for cameras).
			//temp = pVCap->get(CV_CAP_PROP_CONTRAST);// Contrast of the image (only for cameras).
			//temp = pVCap->get(CV_CAP_PROP_SATURATION);// Saturation of the image (only for cameras).
			//temp = pVCap->get(CV_CAP_PROP_HUE);// Hue of the image (only for cameras).
			//temp = pVCap->get(CV_CAP_PROP_GAIN);// Gain of the image (only for cameras).
			//temp = pVCap->get(CV_CAP_PROP_EXPOSURE);// Exposure (only for cameras).
			//temp = pVCap->get(CV_CAP_PROP_CONVERT_RGB);// Boolean flags indicating whether images should be converted to RGB.
			//temp = pVCap->get(CV_CAP_PROP_WHITE_BALANCE_BLUE_U);// The U value of the whitebalance setting (note: only supported by DC1394 v 2.x backend currently)
			//temp = pVCap->get(CV_CAP_PROP_WHITE_BALANCE_RED_V);// The V value of the whitebalance setting (note: only supported by DC1394 v 2.x backend currently)
			//temp = pVCap->get(CV_CAP_PROP_RECTIFICATION);// Rectification flag for stereo cameras (note: only supported by DC1394 v 2.x backend currently)
			//temp = pVCap->get(CV_CAP_PROP_ISO_SPEED);// The ISO speed of the camera (note: only supported by DC1394 v 2.x backend currently)
			//temp = pVCap->get(CV_CAP_PROP_OPENNI_MAX_BUFFER_SIZE);//

			//temp = pVCap->get(CV_CAP_PROP_OPENNI_OUTPUT_MODE);//      = 100,
			//temp = pVCap->get(CV_CAP_PROP_OPENNI_FRAME_MAX_DEPTH);//  = 101, // in mm
			//temp = pVCap->get(CV_CAP_PROP_OPENNI_BASELINE );//        = 102, // in mm
			//temp = pVCap->get(CV_CAP_PROP_OPENNI_FOCAL_LENGTH );//    = 103, // in pixels
			//temp = pVCap->get(CV_CAP_PROP_OPENNI_REGISTRATION );//    = 104, // flag
			//temp = pVCap->get(CV_CAP_PROP_OPENNI_REGISTRATION_ON);//  = CV_CAP_PROP_OPENNI_REGISTRATION, // flag that synchronizes the remapping depth map to image map
			//																	  // by changing depth generator's view point (if the flag is "on") or
			//																	  // sets this view point to its normal one (if the flag is "off").
			//temp = pVCap->get(CV_CAP_PROP_OPENNI_APPROX_FRAME_SYNC);//  = 105,
			//temp = pVCap->get(CV_CAP_PROP_OPENNI_MAX_BUFFER_SIZE);//    = 106,
			//temp = pVCap->get(CV_CAP_PROP_OPENNI_CIRCLE_BUFFER);//      = 107,
			//temp = pVCap->get(CV_CAP_PROP_OPENNI_MAX_TIME_DURATION );// = 108,

			//temp = pVCap->get(CV_CAP_PROP_OPENNI_GENERATOR_PRESENT);//  = 109,

			//temp = pVCap->get(CV_CAP_OPENNI_IMAGE_GENERATOR_PRESENT);//          = CV_CAP_OPENNI_IMAGE_GENERATOR + CV_CAP_PROP_OPENNI_GENERATOR_PRESENT,
			//temp = pVCap->get(CV_CAP_OPENNI_IMAGE_GENERATOR_OUTPUT_MODE );//     = CV_CAP_OPENNI_IMAGE_GENERATOR + CV_CAP_PROP_OPENNI_OUTPUT_MODE,
			//temp = pVCap->get(CV_CAP_OPENNI_DEPTH_GENERATOR_BASELINE);//         = CV_CAP_OPENNI_DEPTH_GENERATOR + CV_CAP_PROP_OPENNI_BASELINE,
			//temp = pVCap->get(CV_CAP_OPENNI_DEPTH_GENERATOR_FOCAL_LENGTH );//    = CV_CAP_OPENNI_DEPTH_GENERATOR + CV_CAP_PROP_OPENNI_FOCAL_LENGTH,
			//temp = pVCap->get(CV_CAP_OPENNI_DEPTH_GENERATOR_REGISTRATION);//     = CV_CAP_OPENNI_DEPTH_GENERATOR + CV_CAP_PROP_OPENNI_REGISTRATION,
			//temp = pVCap->get(CV_CAP_OPENNI_DEPTH_GENERATOR_REGISTRATION_ON);//  = CV_CAP_OPENNI_DEPTH_GENERATOR_REGISTRATION,

			//// Properties of cameras available through GStreamer interface
			//temp = pVCap->get(CV_CAP_GSTREAMER_QUEUE_LENGTH );//   = 200, // default is 1
			//temp = pVCap->get(CV_CAP_PROP_PVAPI_MULTICASTIP);// 

			//temp = pVCap->get(CV_CAP_PROP_XI_DOWNSAMPLING);//  = 400,      // Change image resolution by binning or skipping.
			//temp = pVCap->get(CV_CAP_PROP_XI_DATA_FORMAT );//  = 401,       // Output data format.
			//temp = pVCap->get(CV_CAP_PROP_XI_OFFSET_X);//      = 402,      // Horizontal offset from the origin to the area of interest (in pixels).
			//temp = pVCap->get(CV_CAP_PROP_XI_OFFSET_Y);//      = 403,      // Vertical offset from the origin to the area of interest (in pixels).
			//temp = pVCap->get(CV_CAP_PROP_XI_TRG_SOURCE);//    = 404,      // Defines source of trigger.
			//temp = pVCap->get(CV_CAP_PROP_XI_TRG_SOFTWARE );// = 405,      // Generates an internal trigger. PRM_TRG_SOURCE must be set to TRG_SOFTWARE.
			//temp = pVCap->get(CV_CAP_PROP_XI_GPI_SELECTOR);//  = 406,      // Selects general purpose input
			//temp = pVCap->get(CV_CAP_PROP_XI_GPI_MODE );//     = 407,      // Set general purpose input mode
			//temp = pVCap->get(CV_CAP_PROP_XI_GPI_LEVEL);//     = 408,      // Get general purpose level
			//temp = pVCap->get(CV_CAP_PROP_XI_GPO_SELECTOR );// = 409,      // Selects general purpose output
			//temp = pVCap->get(CV_CAP_PROP_XI_GPO_MODE );//     = 410,      // Set general purpose output mode
			//temp = pVCap->get(CV_CAP_PROP_XI_LED_SELECTOR);//  = 411,      // Selects camera signalling LED
			//temp = pVCap->get(CV_CAP_PROP_XI_LED_MODE );//     = 412,      // Define camera signalling LED functionality
			//temp = pVCap->get(CV_CAP_PROP_XI_MANUAL_WB );//    = 413,      // Calculates White Balance(must be called during acquisition)
			//temp = pVCap->get(CV_CAP_PROP_XI_AUTO_WB  );//     = 414,      // Automatic white balance
			//temp = pVCap->get(CV_CAP_PROP_XI_AEAG );//         = 415,      // Automatic exposure/gain
			//temp = pVCap->get(CV_CAP_PROP_XI_EXP_PRIORITY);//  = 416,      // Exposure priority (0.5 - exposure 50%, gain 50%).
			//temp = pVCap->get(CV_CAP_PROP_XI_AE_MAX_LIMIT);//  = 417,      // Maximum limit of exposure in AEAG procedure
			//temp = pVCap->get(CV_CAP_PROP_XI_AG_MAX_LIMIT);//  = 418,      // Maximum limit of gain in AEAG procedure
			//temp = pVCap->get(CV_CAP_PROP_XI_AEAG_LEVEL );//   = 419,       // Average intensity of output signal AEAG should achieve(in %)
			//temp = pVCap->get(CV_CAP_PROP_XI_TIMEOUT );//      = 420,
			
			// If we reduce the size it works
			pVCap->set(CV_CAP_PROP_FRAME_WIDTH, 3180);
			pVCap->set(CV_CAP_PROP_FRAME_HEIGHT, 2160);

			double mdWidth = pVCap->get(CV_CAP_PROP_FRAME_WIDTH); //get the width of frames of the video
			double mdHeight = pVCap->get(CV_CAP_PROP_FRAME_HEIGHT); //get the height of frames of the video
			int mnWidth = (int)mdWidth;
			int mnHeight = (int)mdHeight;

			if( mnWidth == 0 || mnHeight == 0 )
			{
				return;
			}
		}
		else
		{
			return;
		}

    }
	else
	{
		return;
	}

	if( true )
	{
		namedWindow("Image",CV_WINDOW_NORMAL);
		cvResizeWindow("Image",SMALL_IMAGE_WIDTH,SMALL_IMAGE_HEIGHT);
		cvMoveWindow( "Image",SMALL_IMAGE_WIDTH,SMALL_IMAGE_HEIGHT);
	}

	while( true )
	{
		if( pVCap )
		{
			try
			{
				bSuccess = pVCap->read(frame); // read a new frame from video		
				//resize(frame, frameSmall, Size(SMALL_IMAGE_WIDTH,SMALL_IMAGE_HEIGHT), 0, 0, INTER_CUBIC);
			}
			catch( cv::Exception e )
			{
				break;
			}

			if( bSuccess )
			{
				imshow("Image", frame ); //show the frame in "Image" window
			}
				

			key = waitKey(1);
			if( key == 27 ) 
			{
				break;
			}
		}
		else
		{
			break;
		}
	}

	if( pVCap )
	{
		pVCap->release();
		delete( pVCap);
	}
	
	if( true)
	{
		destroyWindow("Image");
	}

}



int _tmain(int argc, _TCHAR* argv[])
{
	cameraTrd();
	return 0;
}
